diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
index d32e914b4..67bca0761 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
@@ -7,6 +7,7 @@ import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.util.helper.UUIDHelper;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.UUID;
@@ -27,38 +28,36 @@ public class TileEntitySign extends TileEntity
     }
 
     @Override
-	public void writeToNBT(CompoundTag tag)
+	public void writeAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.writeToNBT(tag);
-        tag.putString("Text1", signText[0]);
-        tag.putString("Text2", signText[1]);
-        tag.putString("Text3", signText[2]);
-        tag.putString("Text4", signText[3]);
-        tag.putInt("Picture", selectedPicture);
-        tag.putInt("Color", selectedColor);
-        tag.putBoolean("Glowing", glowing);
-        UUIDHelper.writeToTag(tag, owner, "OwnerUUID");
+        compoundTag.putString("Text1", signText[0]);
+        compoundTag.putString("Text2", signText[1]);
+        compoundTag.putString("Text3", signText[2]);
+        compoundTag.putString("Text4", signText[3]);
+        compoundTag.putInt("Picture", selectedPicture);
+        compoundTag.putInt("Color", selectedColor);
+        compoundTag.putBoolean("Glowing", glowing);
+        UUIDHelper.writeToTag(compoundTag, owner, "OwnerUUID");
     }
 
     @Override
-	public void readFromNBT(CompoundTag tag)
+    public void readAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.readFromNBT(tag);
         for(int i = 0; i < 4; i++)
         {
-            signText[i] = tag.getString("Text" + (i + 1));
+            signText[i] = compoundTag.getString("Text" + (i + 1));
             if(signText[i].length() > MAX_LINE_SIZE)
             {
                 signText[i] = signText[i].substring(0, MAX_LINE_SIZE);
             }
         }
-        selectedPicture = tag.getIntegerOrDefault("Picture", 0);
-        selectedColor = tag.getIntegerOrDefault("Color", 15);
-        glowing = tag.getBooleanOrDefault("Glowing", false);
+        selectedPicture = compoundTag.getIntegerOrDefault("Picture", 0);
+        selectedColor = compoundTag.getIntegerOrDefault("Color", 15);
+        glowing = compoundTag.getBooleanOrDefault("Glowing", false);
 
-        UUID ownerUUID = UUIDHelper.readFromTag(tag, "OwnerUUID");
+        UUID ownerUUID = UUIDHelper.readFromTag(compoundTag, "OwnerUUID");
         if (ownerUUID == null) {
-            String s = tag.getString("Owner");
+            String s = compoundTag.getString("Owner");
             if (!s.isEmpty()) {
                 UUIDHelper.runConversionAction(s,
                     (uuid) -> this.owner = uuid,
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java
index e933f3b10..086a2a629 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java
@@ -51,9 +51,7 @@ public class TileEntityStatue
     private @NotNull Pose pose = Pose.DEFAULT;
 
     @Override
-    public void writeToNBT(CompoundTag tag) {
-        super.writeToNBT(tag);
-
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
         // Write armor
         final @NotNull ListTag list = new ListTag();
         for (int i = 0; i < getNumArmorSlots(); i++) {
@@ -68,25 +66,23 @@ public class TileEntityStatue
                 }
             }
         }
-        tag.putList("Armor", list);
+        compoundTag.putList("Armor", list);
 
         // Write pose
-        tag.putByte("Pose", (byte) this.pose.ordinal());
+        compoundTag.putByte("Pose", (byte) this.pose.ordinal());
 
         // Write held item
         if (getHeldItem() != null) {
             final @NotNull CompoundTag heldItemTag = new CompoundTag();
             getHeldItem().writeToNBT(heldItemTag);
-            tag.putCompound("HeldItem", heldItemTag);
+            compoundTag.putCompound("HeldItem", heldItemTag);
         }
     }
 
     @Override
-    public void readFromNBT(CompoundTag tag) {
-        super.readFromNBT(tag);
-
+    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
         // Read armor
-        final @Nullable ListTag list = tag.getList("Armor");
+        final @Nullable ListTag list = compoundTag.getList("Armor");
         if (list != null) {
             for (Tag<?> t : list) {
                 if (t instanceof CompoundTag) {
@@ -106,14 +102,14 @@ public class TileEntityStatue
         }
 
         // Read pose
-        byte pose = tag.getByteOrDefault("Pose", (byte) Pose.DEFAULT.ordinal());
+        byte pose = compoundTag.getByteOrDefault("Pose", (byte) Pose.DEFAULT.ordinal());
         if (pose < 0 || pose >= Pose.values().length) {
             pose = (byte) Pose.DEFAULT.ordinal();
         }
         this.pose = Pose.values()[pose];
 
         // Read held item
-        final @Nullable CompoundTag heldItemTag = tag.getCompoundOrDefault("HeldItem", null);
+        final @Nullable CompoundTag heldItemTag = compoundTag.getCompoundOrDefault("HeldItem", null);
         if (heldItemTag != null) {
             final @Nullable ItemStack heldItem = ItemStack.readItemStackFromNbt(heldItemTag);
             if (heldItem != null) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index d2c26dfd3..dbab2da7e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -23,6 +23,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
@@ -101,10 +102,9 @@ public class TileEntityTrommel extends TileEntity
     }
 
     @Override
-	public void readFromNBT(CompoundTag nbttagcompound)
+	public void readAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.readFromNBT(nbttagcompound);
-        ListTag nbttaglist = nbttagcompound.getList("Items");
+        ListTag nbttaglist = compoundTag.getList("Items");
         itemStacks = new ItemStack[getContainerSize()];
         for(int i = 0; i < nbttaglist.tagCount(); i++)
         {
@@ -116,17 +116,16 @@ public class TileEntityTrommel extends TileEntity
             }
         }
 
-        burnTime = nbttagcompound.getShort("BurnTime");
-        itemPopTime = nbttagcompound.getShort("CookTime");
+        burnTime = compoundTag.getShort("BurnTime");
+        itemPopTime = compoundTag.getShort("CookTime");
         currentItemBurnTime = getItemBurnTime(itemStacks[1]);
     }
 
     @Override
-	public void writeToNBT(CompoundTag nbttagcompound)
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.writeToNBT(nbttagcompound);
-        nbttagcompound.putShort("BurnTime", (short) burnTime);
-        nbttagcompound.putShort("CookTime", (short) itemPopTime);
+        compoundTag.putShort("BurnTime", (short) burnTime);
+        compoundTag.putShort("CookTime", (short) itemPopTime);
         ListTag nbttaglist = new ListTag();
         for(int i = 0; i < itemStacks.length; i++)
         {
@@ -139,7 +138,7 @@ public class TileEntityTrommel extends TileEntity
             }
         }
 
-        nbttagcompound.put("Items", nbttaglist);
+        compoundTag.put("Items", nbttaglist);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index 1e44799d6..197dcd691 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -9,6 +9,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
@@ -188,38 +189,36 @@ public class TileEntityMovingPistonBlock extends TileEntity
     }
 
     @Override
-	public void readFromNBT(CompoundTag tag)
-    {
-        super.readFromNBT(tag);
-        movedId = tag.getInteger("blockId");
-        movedData = tag.getInteger("blockData");
-        if (tag.containsKey("tileEntity")) {
-            CompoundTag entityTag = tag.getCompound("tileEntity");
+    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
+        movedId = compoundTag.getInteger("blockId");
+        movedData = compoundTag.getInteger("blockData");
+        if (compoundTag.containsKey("tileEntity")) {
+            CompoundTag entityTag = compoundTag.getCompound("tileEntity");
             movedEntity = TileEntityDispatcher.createAndLoadEntity(entityTag);
         }
-        direction = Direction.getDirectionById(tag.getInteger("facing"));
-        progressO = progress = tag.getFloat("progress");
-        extending = tag.getBoolean("extending");
+        direction = Direction.getDirectionById(compoundTag.getInteger("facing"));
+        progressO = progress = compoundTag.getFloat("progress");
+        extending = compoundTag.getBoolean("extending");
     }
 
     @Override
-	public void writeToNBT(CompoundTag tag)
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.writeToNBT(tag);
-        tag.putInt("blockId", movedId);
-        tag.putInt("blockData", movedData);
+        compoundTag.putInt("blockId", movedId);
+        compoundTag.putInt("blockData", movedData);
         if (movedEntity != null) {
             CompoundTag entityTag = new CompoundTag();
             movedEntity.writeToNBT(entityTag);
-            tag.put("tileEntity", entityTag);
+            compoundTag.put("tileEntity", entityTag);
         }
-        tag.putInt("facing", direction.getId());
-        tag.putFloat("progress", progressO);
-        tag.putBoolean("extending", extending);
+        compoundTag.putInt("facing", direction.getId());
+        compoundTag.putFloat("progress", progressO);
+        compoundTag.putBoolean("extending", extending);
     }
 
     @Override
     public boolean canBeCarried(World world, Entity potentialHolder) {
+        // Explicitly defined as false since the MovingPistonBlock should *never* be carried
         return false;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 364b45ff6..8b8c47d2f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -859,16 +859,6 @@ public abstract class Mob extends Entity
 
             float f3 = 0.1627714F / (movementScale * movementScale * movementScale);
             moveRelative(moveStrafing, moveForward, onGround ? speed * f3 : flySpeed);
-            movementScale = 0.91F;
-            if(onGround)
-            {
-                movementScale = 0.5460001F;
-                if(floorBlockId > 0)
-                {
-                    movementScale = Blocks.blocksList[floorBlockId].friction * 0.91F;
-                }
-
-            }
             if(canClimb())
             {
                 float f4 = 0.15F;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
index ad76c65fa..13a350c64 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
@@ -17,13 +17,20 @@ public abstract class MobMonsterArmored<T extends IArmorShape>
     extends MobMonster
     implements IArmorWearing<T>, IItemHolding {
 
-    private static final int DATA_ITEM_HELD = 24;
-    private static final int DATA_ARMOR_START = 25;
+    protected static final int DATA_ITEM_HELD = 24;
+    protected static final int DATA_ARMOR_START = 25;
+    protected static final int FLAG_LEFT_HANDED = 4;
 
     public MobMonsterArmored(final @Nullable World world) {
         super(world);
     }
 
+    @Override
+    public void spawnInit() {
+        super.spawnInit();
+        setSharedFlag(FLAG_LEFT_HANDED, this.random.nextInt(10) == 0);
+    }
+
     @Override
     public @Nullable ItemStack getItemInArmorSlot(final @NotNull T slot) {
         return this.entityData.getItemStack(DATA_ARMOR_START + slot.getSlotIndex());
@@ -46,7 +53,7 @@ public abstract class MobMonsterArmored<T extends IArmorShape>
 
     @Override
     public boolean isLeftHanded() {
-        return false;
+        return getSharedFlag(FLAG_LEFT_HANDED);
     }
 
     @Override
@@ -76,6 +83,7 @@ public abstract class MobMonsterArmored<T extends IArmorShape>
             }
         }
         tag.putList("Armor", list);
+        tag.putBoolean("LeftHanded", getSharedFlag(FLAG_LEFT_HANDED));
     }
 
     @Override
@@ -100,6 +108,7 @@ public abstract class MobMonsterArmored<T extends IArmorShape>
                 }
             }
         }
+        setSharedFlag(FLAG_LEFT_HANDED, tag.getBoolean("LeftHanded"));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 8a7d9fa9f..4a1e29987 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -40,7 +40,6 @@ import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.EnumSleepStatus;
-import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
@@ -1563,7 +1562,7 @@ public abstract class Player
         return lastDeathCoordinate;
     }
 
-    public void pickBlock(int x, int y, int z) {
+    public void pickBlock(int x, int y, int z, boolean pickFully) {
         Block<?> block = world.getBlock(x, y, z);
     	int meta = world.getBlockMetadata(x, y, z);
     	
@@ -1578,11 +1577,17 @@ public abstract class Player
     	if(selectItem == null) {
     		return;
     	}
+
+        if (pickFully && gamemode == Gamemode.creative && tileEntity != null) {
+            CompoundTag entityTag = new CompoundTag();
+            tileEntity.writeAdditionalData(entityTag);
+            selectItem.getData().put("tileEntityData", entityTag);
+        }
     	
 		//Find item in hotbar, and select it
 		for(int i=0; i < 9; i++) {
 			ItemStack stack = inventory.getItem(i + inventory.getHotbarOffset());
-			if(stack != null && stack.itemID == selectItem.itemID && stack.getMetadata() == selectItem.getMetadata()) {
+			if(stack != null && stack.itemID == selectItem.itemID && stack.getMetadata() == selectItem.getMetadata() && stack.getData().equals(selectItem.getData())) {
 				setCurrentItem(i + inventory.getHotbarOffset());
 				return;
 			}
@@ -1604,7 +1609,7 @@ public abstract class Player
 		int stackSize = -1;
 		for(int i=9; i < 36; i++) {
 			ItemStack stack = inventory.getItem(i);
-			if(stack != null && stack.itemID == selectItem.itemID && stack.getMetadata() == selectItem.getMetadata()) {
+			if(stack != null && stack.itemID == selectItem.itemID && stack.getMetadata() == selectItem.getMetadata() && stack.getData().equals(selectItem.getData())) {
 				if(stackSize == -1 || stack.stackSize < stackSize) {
 					itemSlot = i;
 					stackSize = stack.stackSize;
@@ -1714,10 +1719,26 @@ public abstract class Player
 
     public static class PlayerConfig {
         public static final int MASK_LEFT_HAND = 0b0000_0001;
+        public static final int MASK_CAPE = 0b0000_0010;
+        public static final int MASK_OUTER_HEAD = 0b0000_0100;
+        public static final int MASK_OUTER_TORSO = 0b0000_1000;
+        public static final int MASK_OUTER_ARM_LEFT = 0b0001_0000;
+        public static final int MASK_OUTER_ARM_RIGHT = 0b0010_0000;
+        public static final int MASK_OUTER_LEG_LEFT = 0b0100_0000;
+        public static final int MASK_OUTER_LEG_RIGHT = 0b1000_0000;
 
         public PlayerConfigListener listener;
         public byte config = 0;
 
+        private void setToggle(boolean flag, int mask) {
+            if (flag) {
+                config = (byte) (config | mask);
+            } else {
+                config = (byte) (config & ~mask);
+            }
+            if (listener != null) listener.onValueChange();
+        }
+
         public void assignListener(PlayerConfigListener listener) {
             this.listener = listener;
         }
@@ -1725,15 +1746,22 @@ public abstract class Player
         public boolean isLeftHand() {
             return (config & MASK_LEFT_HAND) != 0;
         }
-
-        public void setLeftHand(boolean leftHand) {
-            if (leftHand) {
-                config |= MASK_LEFT_HAND;
-            } else {
-                config &= ~MASK_LEFT_HAND;
-            }
-            if (listener != null) listener.onValueChange();
-        }
+        public boolean capeEnabled() {return (config & MASK_CAPE) != 0;}
+        public boolean hatEnabled() {return (config & MASK_OUTER_HEAD) != 0;}
+        public boolean jacketEnabled() {return (config & MASK_OUTER_TORSO) != 0;}
+        public boolean sleeveLeftEnabled() {return (config & MASK_OUTER_ARM_LEFT) != 0;}
+        public boolean sleeveRightEnabled() {return (config & MASK_OUTER_ARM_RIGHT) != 0;}
+        public boolean pantLeftEnabled() {return (config & MASK_OUTER_LEG_LEFT) != 0;}
+        public boolean pantRightEnabled() {return (config & MASK_OUTER_LEG_RIGHT) != 0;}
+
+        public void setLeftHand(boolean leftHand) {setToggle(leftHand, MASK_LEFT_HAND);}
+        public void setCape(boolean cape) {setToggle(cape, MASK_CAPE);}
+        public void setHat(boolean hat) {setToggle(hat, MASK_OUTER_HEAD);}
+        public void setJacket(boolean jacket) {setToggle(jacket, MASK_OUTER_TORSO);}
+        public void setSleeveLeft(boolean sleeveLeft) {setToggle(sleeveLeft, MASK_OUTER_ARM_LEFT);}
+        public void setSleeveRight(boolean sleeveRight) {setToggle(sleeveRight, MASK_OUTER_ARM_RIGHT);}
+        public void setPantLeft(boolean pantLeft) {setToggle(pantLeft, MASK_OUTER_LEG_LEFT);}
+        public void setPantRight(boolean pantRight) {setToggle(pantRight, MASK_OUTER_LEG_RIGHT);}
 
         public interface PlayerConfigListener {
             void onValueChange();
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
index 14eac3f09..b3ad57d07 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
@@ -67,7 +67,7 @@ public class EntityBoat extends Entity
         CompoundTag flagData = this.flag.getData().getCompoundOrDefault("FlagData", null);
         if (flagData != null)
         {
-            this.tileEntityFlag.readFlagNBT(flagData);
+            this.tileEntityFlag.readAdditionalData(flagData);
         }
     }
 
@@ -238,6 +238,7 @@ public class EntityBoat extends Entity
         zo = z;
         final int waterSections = 5;
         double bouyancy = 0.0D;
+        boolean inWater = false;
         for(int i = 0; i < waterSections; i++) // Splits the boat into individual sections to measure how submerged it is, 1 being fully submerged, 0 being fully exposed
         {
             double minY = (bb.minY + ((bb.maxY - bb.minY) * (double)(i)) / (double)waterSections) - 0.125D;
@@ -246,6 +247,7 @@ public class EntityBoat extends Entity
             if(world.isAABBInMaterial(axisalignedbb, Material.water))
             {
                 bouyancy += 1.0D / (double)waterSections;
+                inWater = true;
             }
         }
 
@@ -302,7 +304,7 @@ public class EntityBoat extends Entity
 
         move(xd, yd, zd);
         double horizontalSpeed = Math.sqrt(xd * xd + zd * zd);
-        if(horizontalSpeed > 0.15D)
+        if(inWater && horizontalSpeed > 0.15D)
         {
             double d12 = Math.cos(((double) yRot * Math.PI) / 180D);
             double d15 = Math.sin(((double) yRot * Math.PI) / 180D);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index 81d25488f..b821ac823 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -267,6 +267,12 @@ public class EntityMinecart extends Entity implements Container {
         if(timeSinceHit > 0) timeSinceHit--;
         if(currentDamage > 0) currentDamage--;
 
+        pushesThisTick = 0;
+        pushTime *= 0.98f;
+        if (pushTime < 0.05f || (pushTime < 0.25 && onGround)){
+            pushTime = 0;
+        }
+
         double _xo = x;
         double _yo = y;
         double _zo = z;
@@ -286,8 +292,33 @@ public class EntityMinecart extends Entity implements Container {
                 setRot(yRot, xRot);
             }
         } else {
+            yd -= 0.08D;
             motionIteration();
             motionIteration();
+
+            int blockX = MathHelper.floor(x);
+            int blockY = MathHelper.floor(y);
+            int blockZ = MathHelper.floor(z);
+            Block<?> block = world.getBlock(blockX, blockY, blockZ);
+            if (block == null || !(block.getLogic() instanceof BlockLogicRail)) {
+                double motionScale = 1;
+
+                if(onGround) {
+                    motionScale = 0.546F;
+                    if(block != null)
+                    {
+                        motionScale = block.friction * 0.91F;
+                    }
+                } else {
+                    motionScale = 0.99;
+                    motionScale = MathHelper.lerp(motionScale, 1f, pushTime);
+                }
+
+                xd *= motionScale;
+                zd *= motionScale;
+
+                move(xd, yd, zd);
+            }
         }
         this.xo = _xo;
         this.yo = _yo;
@@ -300,7 +331,6 @@ public class EntityMinecart extends Entity implements Container {
         xo = x;
         yo = y;
         zo = z;
-        yd -= 0.04D;
         int blockX = MathHelper.floor(x);
         int blockY = MathHelper.floor(y);
         int blockZ = MathHelper.floor(z);
@@ -475,21 +505,6 @@ public class EntityMinecart extends Entity implements Container {
                     }
                 }
             }
-        } else {
-            xd = MathHelper.clamp(xd, -maxSpeed, maxSpeed);
-            zd = MathHelper.clamp(zd, -maxSpeed, maxSpeed);
-
-            if(onGround) {
-                xd *= 0.5D;
-                yd *= 0.5D;
-                zd *= 0.5D;
-            }
-            move(xd, yd, zd);
-            if(!onGround) {
-                xd *= 0.95D;
-                yd *= 0.95D;
-                zd *= 0.95D;
-            }
         }
         xRot = 0.0F;
         double diffX = xo - x;
diff --git a/game/core/src/main/java/net/minecraft/core/item/Item.java b/game/core/src/main/java/net/minecraft/core/item/Item.java
index 8983d06d8..742178d66 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Item.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Item.java
@@ -157,7 +157,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
         return this;
     }
 
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced)
     {
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
index 3fb6abc01..ae294b121 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
@@ -5,6 +5,8 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemBed extends Item
 {
@@ -15,14 +17,14 @@ public class ItemBed extends Item
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced)
     {
     	if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
     		blockX += side.getOffsetX();
     		blockY += side.getOffsetY();
     		blockZ += side.getOffsetZ();
     	}
-        int i1 = entityplayer.getHorizontalPlacementDirection(null).getOpposite().getHorizontalIndex();
+        int i1 = player.getHorizontalPlacementDirection(null).getOpposite().getHorizontalIndex();
         byte byte0 = 0;
         byte byte1 = 0;
         if(i1 == 0)
@@ -43,8 +45,8 @@ public class ItemBed extends Item
         }
         if(world.isAirBlock(blockX, blockY, blockZ) && world.isAirBlock(blockX + byte0, blockY, blockZ + byte1) && world.canPlaceOnSurfaceOfBlock(blockX, blockY - 1, blockZ) && world.canPlaceOnSurfaceOfBlock(blockX + byte0, blockY - 1, blockZ + byte1))
         {
-            if(world.canBlockBePlacedAt(Blocks.BED.id(), blockX, blockY, blockZ, false, side) && itemstack.consumeItem(entityplayer)) {
-                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.BED, EnumBlockSoundEffectType.PLACE);
+            if(world.canBlockBePlacedAt(Blocks.BED.id(), blockX, blockY, blockZ, false, side) && itemstack.consumeItem(player)) {
+                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.BED, EnumBlockSoundEffectType.PLACE);
                 world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.BED.id(), i1);
                 world.setBlockAndMetadataWithNotify(blockX + byte0, blockY, blockZ + byte1, Blocks.BED.id(), i1 + 8);
                 return true;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java b/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java
index b276c13d4..c9b7e4302 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java
@@ -7,6 +7,8 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -25,14 +27,14 @@ public class ItemDiscMusic extends Item
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced)
     {
         if(world.getBlockId(blockX, blockY, blockZ) == Blocks.JUKEBOX.id() && world.getBlockMetadata(blockX, blockY, blockZ) == 0)
         {
             if (!world.isClientSide) {
                 Blocks.JUKEBOX.getLogic().playRecord(world, blockX, blockY, blockZ, id);
                 world.playBlockEvent(null, LevelListener.EVENT_JUKEBOX_TOGGLE, blockX, blockY, blockZ, id);
-                itemstack.consumeItem(entityplayer);
+                itemstack.consumeItem(player);
             }
             return true;
         } else
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
index bba919c71..aa488e2c1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
@@ -7,6 +7,8 @@ import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -22,7 +24,7 @@ public class ItemDoor extends Item {
     }
 
 	@Override
-	public boolean onUseItemOnBlock(ItemStack itemstack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced) {
 		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
 			blockX += side.getOffsetX();
 			blockY += side.getOffsetY();
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
index 0b53ff9e3..645c306a7 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
@@ -7,13 +7,15 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemDoorPainted extends ItemDoor {
     public ItemDoorPainted(String name, String namespaceId, int id, Block<?> doorBottom, Block<?> doorTopId) {
         super(name, namespaceId, id, doorBottom, doorTopId);
     }
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced) {
         if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
             blockX += side.getOffsetX();
             blockY += side.getOffsetY();
